package jminhep.algorithms;

import jminhep.cluster.DataPoint;


/**
 * Represents an abstraction for a cluster of data points in many dimensional space
 * @author S.Chekanov, M.Somaiya 
 */
 class Cluster {


	/** Cluster Number */
	private int clusterNumber;


	/** Mean data point of this cluster */
	private DataPoint mean;


	/**
	 * Returns a new instance of cluster
	 *
	 * @param	_clusterNumber	the cluster number of this cluster
	 */
	public Cluster(int _clusterNumber) {

		this.clusterNumber = _clusterNumber;

	} // end of cluster()


	/**
	 * Sets the mean data point of this cluster
	 *
	 * @param	meanDataPoint	the new mean data point for this cluster
	 */
	public void setMean(DataPoint meanDataPoint) {

		this.mean = meanDataPoint;

	} // end of setMean()


	/**
	 * Returns the mean data point of this cluster
	 *
	 * @return	the mean data point of this cluster
	 */
	public DataPoint getMean() {

		return this.mean;

	} // end of getMean()


	/**
	 * Returns the cluster number of this cluster
	 *
	 * @return	the cluster number of this cluster
	 */
	public int getClusterNumber() {

		return this.clusterNumber;

	} // end of getClusterNumber()


	/**
	 * Main method -- to test the cluster class
	 *
	 * @param	args	command line arguments
	 */
	public static void main(String[] args) {

		Cluster c1 = new Cluster(1);

                double [] a1= new double[3];
                a1[0]=2.;
                a1[1]=3.;
                a1[2]=1.;
		c1.setMean(new DataPoint(a1,3));
		System.out.println(c1.getMean());


	} // end of main()

} // end of class

