package jminhep.gui;

import java.awt.Toolkit;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import java.awt.Dimension;

import jminhep.cluster.DataHolder;

/**
 * <p>
 * Title: Main project file
 * </p>
 * 
 * <p>
 * Description:
 * </p>
 * 
 * <p>
 * Copyright: Copyright (c) 2006. JMinHep
 * </p>
 *
 * 
 * @author S.Chekanov
 * @version 1.0
 */
public class Main {
	boolean packFrame = false;

	public static String input_file = "";

	/**
	 * Construct and show the application.
	 */
	public Main() {

		// Center the window
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		SetEnv.SizeFrame((int) (0.8 * screenSize.width),
				(int) (0.75 * screenSize.height));

		MainFrame frame = new MainFrame(input_file);
		// Validate frames that have preset sizes
		// Pack frames that have useful preferred size info, e.g. from their
		// layout
		if (packFrame) {
			frame.pack();
		} else {
			frame.validate();
		}

		// Center the window
		Dimension frameSize = frame.getSize();
		if (frameSize.height > screenSize.height) {
			frameSize.height = screenSize.height;
		}
		if (frameSize.width > screenSize.width) {
			frameSize.width = screenSize.width;
		}
		frame.setLocation((screenSize.width - frameSize.width) / 2,
				(screenSize.height - frameSize.height) / 2);
		frame.setVisible(true);
	}


	
	/**
	 * Show GUI and append data to it
	 * @param d input data
	 */
	public Main(DataHolder d) {

		// Center the window
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		SetEnv.SizeFrame((int) (0.8 * screenSize.width),
				(int) (0.75 * screenSize.height));

		MainFrame frame = new MainFrame(d);
		// Validate frames that have preset sizes
		// Pack frames that have useful preferred size info, e.g. from their
		// layout
		if (packFrame) {
			frame.pack();
		} else {
			frame.validate();
		}

		// Center the window
		Dimension frameSize = frame.getSize();
		if (frameSize.height > screenSize.height) {
			frameSize.height = screenSize.height;
		}
		if (frameSize.width > screenSize.width) {
			frameSize.width = screenSize.width;
		}
		frame.setLocation((screenSize.width - frameSize.width) / 2,
				(screenSize.height - frameSize.height) / 2);
		frame.setVisible(true);
	}
	
	
	
	
	
	
	
	/**
	 * Application entry point.
	 * 
	 * @param args
	 *            String[]
	 */
	public static void main(String[] args) {

		input_file = "";
		if (args.length > 0)
			input_file = args[0];

		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				try {
					// UIManager.setLookAndFeel(UIManager.
					// getSystemLookAndFeelClassName());
					UIManager.setLookAndFeel(UIManager
							.getCrossPlatformLookAndFeelClassName());

				} catch (Exception exception) {
					exception.printStackTrace();
				}

				new Main();

			}
		});
	}
}
